import 'dart:convert';
import 'dart:io';

import 'builder_dart.dart';

Future<void> main(List<String> arguments) async {
  if (arguments.contains('build')) {
    final saveDir = Directory('').listSync();
    if (saveDir.where((element) => element.path.toLowerCase().contains('database')).isNotEmpty) {
      await savePath('lib/database/model', '');
      for (var i in Directory('database').listSync(recursive: true)) {
        if (i is Directory) return;
        final file = File(i.path);
        final reads = json.decode(await file.readAsString());
        reads.forEach((k, v) async {
          final que = Query(key: k, value: v);
          que.header();
          que.newIndent();
          que.attribute();
          que.startBuildTable();
          que.startBuildGet();
          que.startBuildInsert();
          que.closeIndent();
          final file = File('lib/database/model/$k.dart');
          if (await file.exists()) {
            await file.delete();
          }
          file.writeAsString(que.build());
          file.create();
        });
      }
      print('Success generate model');
    } else {
      Directory('database').create();
      final file = File('database/generate.json');
      file.writeAsString(
        json.encode(
          {
            "data_user": {"name": "String", "id": "integer|primary_key|auto_increment"}
          },
        ),
      );
      file.create();
      print('file has been generated');
    }
  }
}
